;carregamento de funes auxiliares
(defun c:k ()
  (load "c:/autolisp/lisp/lisp_01.lsp")
  (load "c:/autolisp/lisp/lisp_02.lsp")
)
;;;(load "c:/autolisp/auxiliares")

;Arquivo de testes para o curso de AutoLISP
;Iniciado em 27/03/13
;por Denio Guimares


;Aula 01 - Desenho de Retngulo
(defun c:r1 ()
  (command "line" "0,0" "@8<0" "@5<90" "@8<180" "c")
  (princ)
)


;Aula 02 - Comandos diretos do AutoCAD
(defun c:pl1 ()
  (command "_pline" pause "@8<0" "@5<90" pause "c")
  (princ)
)

;funo do primeiro grau
(defun c:g1 ()
  (setq x (getreal "\nEntre com o valor de X... ")
        y (+ (* 2 x) 1)
  )
)

;insero de vaso sanitrio
(defun c:vs ()
  (setq p1 (getpoint "\nEntre com o ponto de insero do vaso... "))  
  (command "_insert" "c:/autolisp/blocos/vaso" "_s" "1" p1)
)

;insero de vaso sanitrio
(defun c:leg (/ teto piso)
  (setq p1 (getpoint "\nEntre com o ponto de insero do legenda... ")
	teto (getstring "\nCdigo do Teto...: ")
	piso (getstring "\nCdigo do Piso...: ")
  )
  (guarda_status)
  (setvar "clayer" "revises")
  (setvar "attdia" 0)
  (setvar "osmode" 0)
  (command "_insert" "c:/autolisp/blocos/legenda" "_s" "1" "_non" p1 "0" teto piso)
  (devolve_status)
)

;funo de deciso
(defun c:dec ()
  (initget 1)
  (setq resposta (getkword "\nDigite A ou B...: "))
  (if (= resposta "A")
    (alert "A")
    (if (= resposta "B")
      (alert "B")
      (progn
	(alert "Entrada Invlida")
	(exit)
      )
    )
  )
  (princ)
)

;pick area
(defun c:pk2 () (pk2_main))

(defun pk2_main ()
  (initget 128)
  (setq p1 (getpoint "\nSelecione polyline/Marcar pontos/<Clique em um ponto interno>..."))
  (cond
    ((= 'LIST (type p1)) (pk2_pickpoint))
    ((= 'STR (type p1))
     (cond
       ((= (strcase p1) "S") (pk2_select))
       ((= (strcase p1) "M") (pk2_mark))
       (t (prompt "\nEntrada Invlida!"))
     )
    (t (prompt "\nEntrada Invlida!"))
   )
  )
)


(defun pk2_pickpoint ()
  (guarda_status)
  (crl "contorno" 7)
  (setvar "osmode" 0)
  (command "_boundary" p1 "")
  (command "_area" "o" "l")
  (setq resp "No")
  (initget 1 "Sim No Yes No")
  (setq resp (getkword "Concorda com a rea selecionada <S/N>... "))
  (while
    (or (= resp "No") (= resp "No"))
    (command "_erase" "l" "")
    (pk2_main)
  )
  (command "_erase" "l" "")
  (pk2_texto)
)

;criao do texto com a rea
(defun pk2_texto ()
  (setq pk2_tpoint (getpoint "\nMarque a posio do Texto... "))
  (command "_text" "_c" pk2_tpoint 0.1 0
	   (strcat (rtos (getvar "area") 2 2) " m2"))
)

;Selecionar poliline
(defun pk2_select () (alert "seleo de poliline"))

;Marcar Pontos
(defun pk2_mark () (alert "marcar"))


;Seo de funes auxiliares

;guarda o satutus do autocad
(defun guarda_status ()
  (setq laymo (getvar "clayer"))
  (setq attmo (getvar "attdia"))
  (setq osnmo (getvar "osmode"))
)

;devolver o status do autocad
(defun devolve_status ()
  (setvar "clayer" laymo)
  (setvar "attdia" attmo)
  (setvar "osmode" osnmo)
)
  
;desenho de escada
(defun c:ecd ()
  (ecd_file)
  (setq ecd_largura (getreal (strcat "\nEntre com o valor da largura... <" ecd_larg ">: "))
	ecd_altura (getreal (strcat "\nEntre com o valor da ALTURA... <" ecd_altu ">: "))
	ecd_repet (getint "\nEntre com o Nmero de degraus...: ")
	ecd_point (getpoint "Clique no ponto inferior da escada...")
  )
  (if (= nil ecd_largura)
    (setq ecd_largura (distof ecd_larg))
    (setq ecd_larg (rtos ecd_largura 2 2))
  )
  (if (= nil ecd_altura) (setq ecd_altura (distof ecd_altu)))
  (repeat ecd_repet
    (setq ecd_p2 (polar ecd_point (/ pi 2) ecd_altura)
	  ecd_p3 (polar ecd_p2 0 ecd_largura)
    )
    (command "_line" "_non" ecd_point  "_non" ecd_p2 ecd_p3 "")
    (setq ecd_point ecd_p3)
  )
  (ecd_writefile)
)

;rotina para ler o arquivo
(defun ecd_file ()
  (setq open_file (open "c:/autolisp/dados/ecd.txt" "r")
	ecd_larg (read-line open_file)
	ecd_altu (read-line open_file)
  )
)

;rotina para escrever o arquivo
(defun ecd_writefile ()
  (setq open_file (open "c:/autolisp/dados/ecd.txt" "w"))
  (write-line ecd_larg open_file)
  (write-line ecd_altu open_file)
)


(defun c:eixo ()
  (setq eixo_p1 (getpoint "\nMarque o centro do eixo...")
	eixo_p2 (getpoint eixo_p1 "\nMarque o segundo ponto...")
	eixo_dir (angle eixo_p1 eixo_p2)
	eixo_p3 (polar eixo_p1 eixo_dir 0.3)
  )
  (command "_circle" "_non" eixo_p1 "_non" eixo_p3 "_line" "_non" eixo_p3 "_non" eixo_p2 "")
)

(defun c:to2 ()
  (prompt "Selecione os objetos para o layer 'Aux_02'...")
  (setq to2_select (ssget '((0 . "CIRCLE"))))
  (eval_layer "lisp_02" "4")
)

(defun c:elist ()
  (setq ent_list (entget (car (entsel))))
)

(defun c:cgl ()
  (prompt "\nSelecione a entidade base...")
  (setq ent_layer (cdr (assoc 8 (entget (car (entsel))))))
  (prompt ent_layer)
  (prompt "\nSelecione as entidades para mudana...")
  (setq s1 (ssget)
	s1_len (sslength s1)
	counter 0
  )
  (repeat s1_len
    (setq ent_list (entget (ssname s1 counter)))
    (entmod (setq ent_list (subst (cons 8 ent_layer) (assoc 8 ent_list) ent_list)))
    (setq counter (1+ counter))
  )
;;;  (command "_change" s1 "" "_p" "_la" ent_layer "")
  (princ)
)

(defun eval_layer (layer_nome layer_cor)
    (if (tblsearch "layer" "Lisp_02")
    (command "_change" to2_select "" "_p" "_la" "Lisp_02" "_c" "_bylayer" "")
    (command "_layer" "_M" "Lisp_02" "_c" "4" "" ""
	     "_change" to2_select "" "_p" "_la" "Lisp_02" "_c" "_bylayer" "")
  )
)


;criao de layers
(defun crl (layname laycol)
  (entmake (list
	     (cons 0 "layer")
	     (cons 100 "AcDbSymbolTableRecord")
	     (cons 100 "AcDbLayerTableRecord")
	     (cons 2 layname)
	     (cons 70 0)
	     (cons 62 laycol)
	     (cons 6 "Continuous")
	   )
  )
)

;criao de layers pessoais
(defun c:layp ()
  (setq lay_list (list
		   (list "cadnorma_01" 1)
		   (list "cadnorma_02" 2)
		   (list "cadnorma_03" 3)
		   (list "cadnorma_04" 4)
		 )
  )
  (foreach n lay_list
    (crl (car n) (cadr n))
  )    
)
	     
  
;colocar pontos na tela
(defun c:pto ()
  (setq arq_dados (getfiled "Selecione o Arquivo de Dados" (getvar "dwgprefix") "txt" 16))
  (setq open_file (open arq_dados "r"))
  (while (/= nil (setq ponto_atual (read-line open_file)))
    (command "_point" ponto_atual)
  )
  (close open_file)
)



(defun cn7_verylayer (cn7_very_layname cn7_laycol)
  (setq cn7_currlayer nil)
  ;se existe o layer solicitado
  (if (/= nil (setq cn7_currlayer (tblsearch "layer" cn7_very_layname)))
    (progn
      (setq cn7_layname (cdr (assoc 2 cn7_currlayer)))
      ;verifica se est desligado
      (if (= -30 (cdr (assoc 62 cn7_currlayer)))
	(progn
	  (cn7_alert_yes_no
	    "O layer solicitado est desligado!"
	    (strcat "layer = " cn7_layname)
	    "Deseja lig-lo e Prosseguir?"
	  )
	  (if (= alert_resp "yes")
	    (command "._layer" "_on" cn7_layname "")
	    (exit)
	  )
	)
      );if
      (cond
	;se (assoc 70)  1, est s freeze
	((= 1 (cdr (assoc 70 cn7_currlayer)))
	 (cn7_alert_yes_no
	   "O layer solicitado est congelado"
	   (strcat "layer = " cn7_layname)
	   "Deseja descongel-lo e Prosseguir?"
	 )
	 (if (= alert_resp "yes")
	   (command "._layer" "_thaw" cn7_layname "")
	   (exit)
	 )
        )
	;se (assoc 70)  4,  s lock
	((= 4 (cdr (assoc 70 cn7_currlayer)))
	 (cn7_alert_yes_no
	   "O layer solicitado est trancado"
	   (strcat "layer = " cn7_layname)
	   "Deseja destranc-lo e Prosseguir?"
	 )
	 (if (= alert_resp "yes")
	   (command "._layer" "_unlock" cn7_layname "")
	   (exit)
	 )
        )
	;se (assoc 70)  5, est freeze e lock
	((= 5 (cdr (assoc 70 cn7_currlayer)))
	 (cn7_alert_yes_no
	   "O layer solicitado est trancado e congelado!"
	   (strcat "layer = " cn7_layname)
	   "Deseja desfazer e Prosseguir?"
	 )
	 (if (= alert_resp "yes")
	   (progn
	     (command "._layer" "_unlock" cn7_layname "")
	     (command "._layer" "_thaw" cn7_layname "")
	   )
	   (exit)
	 )
        )
      );cond
      (command "._layer" "_m" cn7_very_layname "_c" cn7_laycol "" "");(setvar "clayer" cn7_very_layname)
    )
    (progn
      (command "._layer" "_m" cn7_very_layname "_c" cn7_laycol "" "")
      (prompt (strcat "...Criado layer <" (strcase cn7_very_layname) ">, com a cor <" (rtos cn7_laycol 2 0) ">."))
    )
  )
)

;ler dados de atributos
(defun c:atb ()
  (setq e1 (car (entsel)))
  (while (/= "SEQEND" (cdr (assoc 0 (setq proxima (entget (setq e1 (entnext e1)))))))
    (if (= "ATTRIB" (cdr (assoc 0 proxima)))
      (progn
	(if (= "CNQT" (cdr (assoc 2 proxima))) (setq bloco_codigo (cdr (assoc 1 proxima))))
	(if (= "QUANT" (cdr (assoc 2 proxima))) (setq bloco_quant (cdr (assoc 1 proxima))))
      )
    )
  )
  (alert (strcat "codigo: " bloco_codigo "\nquantidade :" bloco_quant))	 
)

 
(prompt "\nComandos Carregados com Sucesso!")
(princ)
